#/////////////////////////////////////////////////////////////////////////////
# FILE:    MMS_layer_gui_repository.tcl
# PURPOSE: Communication layer between MMS and the GUI for Repositories
#/////////////////////////////////////////////////////////////////////////////

namespace eval LayerMMSRepositoriesGui {

#/////////////////////////////////////////////////////////////////////////////
proc GetRepositoryTest {} {
#/////////////////////////////////////////////////////////////////////////////
  return {
    name "Repository 1"
    desc "desc of Repository 1"
    sour ""
    type "folder"
  }
}
  
variable get_repository_test 0
#///////////////////////////////////////////////////////////////////////////
proc GetRepository {ident} {
#///////////////////////////////////////////////////////////////////////////
  variable get_repository_test
  
  if { $get_repository_test } {
    return [GetRepositoryTest]
  }
  LayerMMSGui::EvalTolFun "MMS::Layer::MMSRepositoriesGui::GetRepository" \
    "Set" $ident
}

#/////////////////////////////////////////////////////////////////////////////
proc GetRepositoriesListTest { } {
#/////////////////////////////////////////////////////////////////////////////
  return {
    {}
    {
      name "Repository 1"
	  type "folder"
    }
    {}
    {
      name "Repository 2"
	  type "database"
    }
  }
}
  
variable get_repositories_test 0
#/////////////////////////////////////////////////////////////////////////////
proc GetRepositoriesList {details} {
#/////////////////////////////////////////////////////////////////////////////
  variable get_repositories_test
  
  if { $get_repositories_test } {
    return [GetRepositoriesListTest]
  }
  LayerMMSGui::EvalTolFun "MMS::Layer::MMSRepositoriesGui::GetRepositoriesList" \
    "Set" $details
}

#///////////////////////////////////////////////////////////////////////////
proc GetRepositoryHelp {} {
#///////////////////////////////////////////////////////////////////////////
  
  LayerMMSGui::EvalTolFunArgNoChg "MMS::Layer::MMSRepositoriesGui::GetRepositoryHelp" \
    "Text" "?"
}

variable create_repository_test 0
#///////////////////////////////////////////////////////////////////////////
proc CreateRepository {repository_info} {
#///////////////////////////////////////////////////////////////////////////
  variable create_repository_test
  upvar $repository_info arrayarg
  
  if { $create_repository_test } {
    LayerMMSGui::EvalTolFunArr "MMS::Layer::MMSRepositoriesGui::CreateRepositoryTest" \
	  "Real" arrayarg
	
  } else {
    LayerMMSGui::EvalTolFunArr "MMS::Layer::MMSRepositoriesGui::CreateRepository" \
	  "Real" arrayarg
  }
}

#/////////////////////////////////////////////////////////////////////////////
proc GetObjectsListTest { } {
#/////////////////////////////////////////////////////////////////////////////
  return {
    {}
    {
      name "object 1"
	  vers "1.0"
    }
    {}
    {
      name "object 2"
	  vers "2.0"
    }
  }
}
  
variable get_objects_test 0
#/////////////////////////////////////////////////////////////////////////////
proc GetObjectsList {container subclass} {
#/////////////////////////////////////////////////////////////////////////////
  variable get_objects_test
  
  if { $get_objects_test } {
    return [GetObjectsListTest]
  }
  LayerMMSGui::EvalTolFun "MMS::Layer::MMSRepositoriesGui::GetObjectsList" \
    "Set" $container $subclass
}

#/////////////////////////////////////////////////////////////////////////////
proc GetObjectsListIncr {container subclass} {
#/////////////////////////////////////////////////////////////////////////////
  LayerMMSGui::EvalTolFun "MMS::Layer::MMSRepositoriesGui::GetObjectsListIncr" \
    "Set" $container $subclass
}

#/////////////////////////////////////////////////////////////////////////////
proc GetVersion {container} {
#/////////////////////////////////////////////////////////////////////////////
  LayerMMSGui::EvalTolFun "MMS::Layer::MMSRepositoriesGui::GetVersion" \
    "Real" $container
}

#/////////////////////////////////////////////////////////////////////////////
proc GetObjectsCatalog {container subclass} {
#/////////////////////////////////////////////////////////////////////////////
  LayerMMSGui::EvalTolFun "MMS::Layer::MMSRepositoriesGui::GetObjectsCatalog" \
    "Set" $container $subclass
}

#/////////////////////////////////////////////////////////////////////////////
proc LoadObjects {name vers container subclass} {
#/////////////////////////////////////////////////////////////////////////////
  
  LayerMMSGui::EvalTolFun "MMS::Layer::MMSRepositoriesGui::LoadObjects" \
    "Real" $name $vers $container $subclass
}

#/////////////////////////////////////////////////////////////////////////////
proc DeleteObjects {name vers container subclass} {
#/////////////////////////////////////////////////////////////////////////////
  
  LayerMMSGui::EvalTolFun "MMS::Layer::MMSRepositoriesGui::DeleteObjects" \
    "Real" $name $vers $container $subclass
}

}
